
import java.applet.Applet;
import java.applet.AudioClip;
import java.io.File;
import java.net.MalformedURLException;
import java.net.URI;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Collections;
import java.util.Comparator;
import java.util.LinkedList;


import javax.swing.JOptionPane;

/**
 * hilfsklasse fr sonstige funktionen
 * //E:\samples\berarbeitete\
 * //File f = new File("\\e:\\samples\\berarbeitete\\Guitar.12.05.2.1.wav");
 * //long nurso = f.length()/1024;
 * @author TET<BR>
 * @created 2006-06-06<BR>
 * @date 	2008-01-23<BR>
 * @version v.0.15<BR>
 */
public class MISC_Tool {
	/**
	 * objekt looft in eigenem thread
	 */
	private static Thread misctool = null;
	private static StringBuilder sb = null;
	private static StringBuilder sbTemp = null;
	/**
	 * konstruktor startet neuen thread
	 */
	public MISC_Tool(){
		misctool = new Thread();
		misctool.start();
	}
	/**
	 * tauscht char "One" gegen char "Other" aus
	 * @param value string der verndert werden soll
	 * @param One gesuchtes zeichen - bsp: '.'
	 * @param Other gewnschtes zeichen - bsp: ','
	 * @return genderten string
	 */
	public static String removeOnereplacewithOther(String value, char One, char Other){
		sb = new StringBuilder(value);
		sbTemp = new StringBuilder();
		for (int x=0;x<sb.length();x++){
			if (sb.charAt(x)!=One){
				sbTemp.append(sb.charAt(x));
			}
			if (sb.charAt(x)==One){
				sbTemp.append(Other);
			}
		}
		return sbTemp.toString();
	}

	public static String removeOneonDelete(StringBuilder sb, char One){
		sbTemp = new StringBuilder();
		for (int x=0;x<sb.length();x++){
			if (sb.charAt(x)!=One){
				sbTemp.append(sb.charAt(x));
			}
			if (sb.charAt(x)==One){ }
		}
		return sbTemp.toString();
	}
	/**
	 * prft auf grafikdateien
	 * @param gesucht
	 * @return true, wenn gefunden
	 */
	public static boolean checkDateiendung(String gesucht){
		boolean gefunden = false;	
		gesucht=gesucht.toLowerCase();
		if (gesucht.endsWith(".gif")){
			gefunden=true;
		}
		if (gesucht.endsWith(".jpg")){
			gefunden=true;
		}
		if (gesucht.endsWith(".png")){
			gefunden=true;
		}
		if (gesucht.endsWith(".ico")){
			gefunden=true;
		}
		return gefunden;
	}

	/**
	 * sound fr erfolgreiches abschliessen
	 * abspielen von "notify.wav" <BR>
	 * @param times <BR>
	 */
	public static void playSoundSuccess(int times){
		for (int i = 0 ; i<times; i++) {
			try {
				File f = new File("\\c:\\WINDOWS\\Media\\notify.wav");				
				long waiter = (750/120)*(f.length()/1024);
				URI uri = f.toURI();
				AudioClip sound = Applet.newAudioClip(uri.toURL());
				sound.play();
				try {
					Thread.sleep(waiter);	//mal das gute stck ausspielen lassen
				} catch (InterruptedException ie){}
			} catch (MalformedURLException e) {
				showPopUpMeldung("Der Ton konnte nicht abgespielt werden, Datei nicht gefunden!");
			}			
		}
	}  //endof playSoundSuccess()

	/**
	 * sound fr fehlermeldung
	 * abspielen von "ringin.wav" <BR>
	 * @param times <BR>
	 */
	public static void playSoundError(int times){
		for (int i = 0 ; i<times; i++) {
			try {
				File f = new File("\\c:\\WINDOWS\\Media\\ringin.wav");				
				long waiter = (750/120)*(f.length()/1024);
				URI uri = f.toURI();
				AudioClip sound = Applet.newAudioClip(uri.toURL());
				sound.play();
				try {
					Thread.sleep(waiter);	//mal das gute stck ausspielen lassen
				} catch (InterruptedException ie){}
			} catch (MalformedURLException e) {
				showPopUpMeldung("Der Ton konnte nicht abgespielt werden, Datei nicht gefunden!");
			}			
		}
	}  //endof playSoundError()

	/**
	 * mitte nach hinten abschneiden <BR>
	 * @param rohdata <BR>
	 * @param startpos <BR>
	 * @return abgeschnippselter string <BR>
	 */
	public static String reduceString(String rohdata, int startpos) {
		sbTemp = new StringBuilder();
		for (int i = startpos; i<rohdata.length(); i++) {
			sbTemp.append(rohdata.charAt(i));
		}
		return sbTemp.toString();
	}

	/**
	 * vorn nach mitte abschneiden <BR>
	 * @param rohdata <BR>
	 * @param endpos <BR>
	 * @return abgeschnippselter string <BR>
	 */
	public static String cutString(String rohdata, int endpos) {
		sbTemp = new StringBuilder();
		for (int i = 0; i<endpos; i++) {
			sbTemp.append(rohdata.charAt(i));
		}
		return sbTemp.toString();
	}
	
	/**
	 * sucht aus einem string ein zeichen und nennt stelle von hinten
	 * bsp :
	 * fr suche nach '/' in "www/root/html/index.html" ergibt 10
	 * fr suche nach '@' in "name@mail.org" ergibt 9 
	 * @param zeile
	 * @param zeichen
	 * @return stelle, an der das gesuchte zeichen steht
	 */
	public static int sucheZeichengibStelle(String zeile, char zeichen){
		sb = new StringBuilder(zeile);
		sb.reverse();
		int merker = 0;
		for (int i=0;i<sb.length();i++) {
			if (sb.charAt(i)==zeichen) {
				merker = i;
				i=sb.length();				
			}
		}		
		merker=sb.length()-merker;
		return merker;
	}
	/**
	 * setzt tausenderpunkte bsp
	 * in	:10000
	 * out	:10.000
	 * @param tolleZahl
	 * @return formatierte zahl
	 */
	public static String machTausenderzeichen(String tolleZahl){
		sb = new StringBuilder( tolleZahl );
		sbTemp = new StringBuilder( );
		sb.reverse();
		int sprung = 0;
		for (int i=0;i<sb.length();i++){
			sbTemp.append(sb.charAt(i));
			sprung++;
			if (sprung==3){
				sbTemp.append(".");
				sprung=0;
			}
		}
		sbTemp.reverse();
		if (sbTemp.toString().startsWith(".")){
			sb.delete(0, sb.length());
			sb.append(sbTemp.substring(1, sbTemp.length()));
			sbTemp=sb;
		}
		return sbTemp.toString();
	}
	/**
	 * lscht ein anfhrendes leerzeichen heraus <br>
	 * @param data <br>
	 * @return gekrzte data <br>
	 */
	public static String filterBlank(String data) {
		while (data.startsWith(" ")) {
			data = reduceString(data,1);
		}
		return data;
	}

	/**
	 * generiert einen sha1 code aus dem string, mit der methode:<br> 
	 * method = "SHA-512"
	 * method = "SHA1" etc.
	 * @param hashMe - zu hashender string<br>
	 * @param method - methode nach der verschlsselt werden soll
	 * @return gehasheter string <br>
	 */
	public static String getHash(String hashMe, String method) {
		try {
			sb = new StringBuilder();
			MessageDigest md = MessageDigest.getInstance(method);
			md.update(hashMe.getBytes());
			byte[] newHash = md.digest();			
			for ( int i = 0; i < newHash.length; i++ ) sb.append(Integer.toHexString(newHash[i]&0xff));
			return sb.toString();
		} catch (NoSuchAlgorithmException nsae) {
			MISC_Tool.showPopUpMeldung("getSHA1Hash(String hashMe) hat nicht geklappt");
			MISC_Tool.playSoundError(3);
			return "getHash(String hashMe, String method) hat nicht geklappt";}
	}

	/**
	 * fllt mit filler von vorne (links) auf
	 * @param interessant = "nur"		(lnge ist interessant)
	 * @param ziel = "hallo"	( -""- )
	 * @param filler = "0" 	(fllzeichen)
	 * @return newString = "00nur"
	 */
	public static String fillLeft(String interessant, String ziel, char filler) {
		sb = new StringBuilder();
		int diff = (ziel.length()-interessant.length());
		if ( diff > 0 ) {
			for (int i=0;i<diff;i++) {
				sb.append(filler);
			}
			for (int i =0;i<interessant.length();i++) {
				sb.append(interessant.charAt(i));
			}
		}
		return sb.toString();
	}

	/**
	 * hilfsmethode die ein popup ffnet  <BR>
	 * "hier gehrt der text rein" <BR>
	 * @param meldung <BR>
	 */
	public static void showPopUpMeldung(String meldung) {
		JOptionPane.showMessageDialog(null, meldung);
	}

	/**
	 * sortiert den "index" absteigend
	 * @param dateiIndex
	 * @return sortierte liste
	 */
	public static LinkedList<MISC_IndexHelper> sortiereIndex(LinkedList<MISC_IndexHelper> dateiIndex){
		Collections.sort(dateiIndex, new MISC_Tool.SortierePICS());
		return dateiIndex;
	}
	/**
	 * comparable sortierer
	 */
	public static class SortierePICS implements Comparator {
		public SortierePICS() {}		
		public int compare(Object a, Object b) {
			MISC_IndexHelper foa = (MISC_IndexHelper)a;
			MISC_IndexHelper fob = (MISC_IndexHelper)b;
			int ergebnis = 1;		
			if (foa.getInhalt().equals(fob.getInhalt())) {
				ergebnis = foa.getInhalt().compareTo(fob.getInhalt());
			} else {
				ergebnis = foa.getInhalt().compareTo(fob.getInhalt());
			}							
			return ergebnis;		
		}
	}
}
